﻿ALTER PROCEDURE [HM].[Hm_dk_generujdokumentwz]
    @id             INT,
    @userID         INT,
    @wybranyMagazyn INT,
    @idDk           INT OUT
AS
    BEGIN
        SET NOCOUNT ON;
        DECLARE @err INT;
        SET @err = 0;
        SET @idDk = 13;
        DECLARE @ID_fak INT = @id;

        --Sprawdzamy czy jednostka miary wprowadzona na pozycjach jest taka sama jak ewidencyjna
        IF EXISTS
            (
                SELECT
                    id
                FROM
                    HM.DP
                WHERE
                    super = @ID_fak
                    AND jm <> jmwp
            )
            RETURN @err;

		-- pozycje inne niż towarowe: komplety, usługi i pozycje niekartotekowe, nie obsługujemy
        IF EXISTS
            (
                SELECT
                    id
                FROM
                    HM.DP
                WHERE
                    super = @ID_fak
                    AND (flag & 0x200) = 0
            )
            RETURN @err;

        IF EXISTS
            (
                SELECT
                        zo.id
                FROM
                        HM.MG dk
                    JOIN
                        HM.TR tr_fak
                            ON dk.id = tr_fak.owner_id
                               AND tr_fak.owner_base = 33
                    JOIN
                        HM.PO po
                            ON po.id2 = tr_fak.id
                    JOIN
                        HM.TR tr_zam
                            ON tr_zam.id = po.id1
                    JOIN
                        HM.DK zo
                            ON zo.id = tr_zam.owner_id
                               AND tr_zam.owner_base = 16
                WHERE
                        zo.id = @id
            )
            BEGIN
                RETURN @err;
            END;
        DECLARE @ile_magazynow INT = (
                                         SELECT
                                                 COUNT(DISTINCT (ISNULL(rez.magazyn, @wybranyMagazyn)))
                                         FROM
                                                 HM.DP poz_zam
                                             LEFT JOIN
                                                 HM.RZ rez
                                                     ON poz_zam.id = rez.idpozrz
                                                        AND iddokrz = @ID_fak
                                         WHERE
                                                 poz_zam.super = @ID_fak
                                                 AND poz_zam.typ <> 0
                                                 AND poz_zam.typ <> 1
                                     );
        IF ISNULL(@ile_magazynow, 0) > 1
            RETURN @err;
        DECLARE @id_trans_fak INT = (
                                        SELECT TOP (1)
                                            id
                                        FROM
                                            HM.TR
                                        WHERE
                                            owner_id = @ID_fak
                                            AND owner_base = 16
                                        ORDER BY
                                            id DESC
                                    );

        --ustalamy kolejny nr dokumentu
        DECLARE
            @seria     VARCHAR(100),
            @numeracja INT,
            @serianr   INT;
        SELECT
                @seria     =
            (
                SELECT TOP (1)
                    kod
                FROM
                    HM.SD
                WHERE
                    idTypDok = TD.id
                    AND aktywny = 1
                ORDER BY
                    id ASC
            ),
                @numeracja = SD.numeracja
        FROM
                HM.DK            DK
            LEFT JOIN
                HM.TD            TD
                    ON TD.id =
                        (
                            SELECT TOP (1)
                                idDokSkojarz
                            FROM
                                HM.TD
                            WHERE
                                kod =
                                (
                                    SELECT TOP (1)
                                        typ_dk
                                    FROM
                                        HM.DK
                                    WHERE
                                        id = @ID_fak
                                    ORDER BY
                                        id DESC
                                )
                            ORDER BY
                                id DESC
                        )
            LEFT JOIN
                HM.SK            SK
                    ON TD.idSchematKs = SK.id
            LEFT JOIN
                HM.SD            SD
                    ON SD.kod =
                        (
                            SELECT TOP (1)
                                kod
                            FROM
                                HM.SD
                            WHERE
                                idTypDok = TD.id
                                AND aktywny = 1
                            ORDER BY
                                id ASC
                        )
                       AND SD.idTypDok = TD.id
            LEFT JOIN
                SSCommon.STUsers us
                    ON DK.wystawil = us.Id
        WHERE
                DK.id = @ID_fak;
        IF @numeracja = 0
            SET @serianr =
            (
                SELECT
                    MAX(serianr)
                FROM
                    HM.MG
                WHERE
                    seria = @seria
            );
        ELSE IF @numeracja = 1
            SET @serianr =
            (
                SELECT
                    MAX(serianr)
                FROM
                    HM.MG
                WHERE
                    seria = @seria
                    AND YEAR(data) = YEAR(GETDATE())
            );
        ELSE IF @numeracja = 2
            SET @serianr =
            (
                SELECT
                    MAX(serianr)
                FROM
                    HM.MG
                WHERE
                    seria = @seria
                    AND YEAR(data) = YEAR(GETDATE())
                    AND MONTH(data) = MONTH(GETDATE())
            );
        ELSE IF @numeracja = 3
            SET @serianr =
            (
                SELECT
                    MAX(serianr)
                FROM
                    HM.MG
                WHERE
                    seria = @seria
                    AND YEAR(data) = YEAR(GETDATE())
                    AND MONTH(data) = MONTH(GETDATE())
                    AND DAY(data) = DAY(GETDATE())
            );
        IF (@seria IS NULL)
            RETURN @err;
        SET @serianr = ISNULL(@serianr, 0) + 1;
        -- koniec ustalania kolejnego nr seryjnego

        DECLARE @wartoscWZ DECIMAL(24, 2) = (
                                                SELECT
                                                    SUM(wartosc)
                                                FROM
                                                    HM.TR
                                                WHERE
                                                    id = @id_trans_fak
                                            );
        DECLARE @id_dzial INT = (
                                    SELECT
                                        magazyn
                                    FROM
                                        HM.DK
                                    WHERE
                                        id = @ID_fak
                                );
        DECLARE @temp_mag INT;
        IF EXISTS
            (
                SELECT
                    id
                FROM
                    HM.ZZ
                WHERE
                    typ = 105
                    AND baza2 = 20
                    AND id1 = @id_dzial
                    AND id2 = @wybranyMagazyn
            )
            SET @temp_mag = @wybranyMagazyn;
        ELSE
            SET @temp_mag = ISNULL(
                                (
                                    SELECT
                                        id2
                                    FROM
                                        HM.ZZ
                                    WHERE
                                        id1 = (@id_dzial)
                                        AND typ = 108
                                        AND baza2 = 20
                                ), 2
                                  );
        DECLARE @id_magazynu INT = ISNULL(
                                       (
                                           SELECT DISTINCT
                                                   (ISNULL(rez.magazyn, @wybranyMagazyn))
                                           FROM
                                                   HM.DP poz_zam
                                               JOIN
                                                   HM.RZ rez
                                                       ON poz_zam.id = rez.idpozrz
                                                          AND iddokrz = @ID_fak
                                           WHERE
                                                   poz_zam.super = @ID_fak
                                                   AND poz_zam.typ <> 0
                                                   AND poz_zam.typ <> 1
                                       ), @temp_mag
                                         );
        INSERT INTO HM.MG
            (
                flag,
                aktywny,
                subtyp,
                typ,
                znacznik,
                rodzaj,
                katalog,
                info,
                kod,
                seria,
                serianr,
                okres,
                seriadzial,
                nazwa,
                data,
                datasp,
                opis,
                khid,
                khadid,
                khdzial,
                ok,
                rr,
                termin,
                netto,
                odebrane,
                typ_dk,
                grupacen,
                rejestrVat,
                iddokkoryg,
                exp_fk,
                wartoscWz,
                magazyn,
                przychod,
                rozchod,
                wartk,
                schemat,
                bufor,
                rozlmg,
                super,
                anulowany,
                wystawil,
                createdBy,
                createdDate,
                modifiedBy,
                modifiedDate,
                statusRDF,
                guid,
                statusFK,
                jpk
            )
                    SELECT
                            0                                                       AS flag,
                            1                                                       AS aktywny,
                            78                                                      AS subtyp,
                            201                                                     AS typ,
                            DK.znacznik                                             AS znacznik,
                            3500                                                    AS rodzaj,  --stała wartość  
                            2500                                                    AS katalog, -- stała wartość 
                            DK.info                                                 AS info,
                            HM.Hm_podajkod(
                                              '', @serianr, SD.szablon, DAY(GETDATE()), MONTH(GETDATE()), YEAR(GETDATE()),
                                              us.LoginName, CASE ini.napis
                                                                WHEN '4'
                                                                    THEN vkh.AccountNo
                                                                WHEN '2'
                                                                    THEN vkh.IdFK
                                                                ELSE
                                                                    0
                                                            END, kon_kh.khfk, kon_kh.kod,
                                              ISNULL(   @id_magazynu,
                                                  (
                                                      SELECT
                                                          id2
                                                      FROM
                                                          HM.ZZ
                                                      WHERE
                                                          typ = 108
                                                          AND baza2 = 20
                                                          AND id1 = DK.magazyn
                                                  )
                                                    ), DK.waluta
                                          )                                         AS kod,
                            (
                                SELECT TOP (1)
                                    kod
                                FROM
                                    HM.SD
                                WHERE
                                    idTypDok = TD.id
                                    AND aktywny = 1
                                ORDER BY
                                    id ASC
                            )                                                       AS SERIA,   -- DO WYLICZENIA,
                            @serianr                                                AS SERIANR, -- DO WYLICZENIA
                            HM.hm_GetCurrPer(@numeracja, GETDATE(), 1)              AS okres,
                            DK.seriadzial                                           AS seriadizal,
                            TD.nazwa                                                AS nazwa,
                            CONVERT(DATE, GETDATE())                                AS data,
                            CONVERT(DATE, GETDATE())                                AS datasp,
                            DK.opis                                                 AS opis,
                            DK.odid                                                 AS khid,
                            DK.odadid                                               AS khadid,
                            NULL                                                    AS khdzial,
                            1                                                       AS ok,
                            DK.rr                                                   AS rr,
                            (CONVERT(DATE, (GETDATE() + ISNULL(TD.terminRozl, 0)))) AS termin,
                            @wartoscWZ                                              AS netto,
                            ''                                                      AS odebrane,
                            TD.kod                                                  AS typ_dk,
                            CASE
                                WHEN DK.subtyp = 124
                                    THEN 1
                                WHEN DK.subtyp = 125
                                    THEN 1
                                ELSE
                                    DK.grupacen
                            END                                                     AS grupacen,
                            TD.idRejestr                                            AS rejestrVat,
                            NULL                                                    AS iddokkoryg,
                            0                                                       AS exp_fk,
                            0                                                       AS wartoscWZ,
                            ISNULL(   @id_magazynu,
                                (
                                    SELECT
                                        id2
                                    FROM
                                        HM.ZZ
                                    WHERE
                                        typ = 108
                                        AND baza2 = 20
                                        AND id1 = DK.magazyn
                                )
                                  )                                                 AS magazyn,
                            0                                                       AS przychód,
                            0                                                       AS rozchod,
                            0                                                       AS wartk,
                            SK.kod                                                  AS schemat,
                            1                                                       AS bufor,
                            1                                                       AS rozlmg,
                            NULL                                                    AS super,
                            0                                                       AS anulowany,
                            @userID                                                 AS wystawil,
                            @userID                                                 AS createdby,
                            GETDATE()                                               AS createdate,
                            DK.modifiedBy                                           AS modifiedby,
                            GETDATE()                                               AS modifiedDate,
                            0                                                       AS statusRDF,
                            NEWID()                                                 AS guid,
                            0                                                       AS statusFK,
                            2                                                       AS jpk
                    FROM
                            HM.DK            DK
                        LEFT JOIN
                            HM.TD            TD
                                ON TD.id =
                                    (
                                        SELECT TOP (1)
                                            idDokSkojarz
                                        FROM
                                            HM.TD
                                        WHERE
                                            kod =
                                            (
                                                SELECT TOP (1)
                                                    typ_dk
                                                FROM
                                                    HM.DK
                                                WHERE
                                                    id = @ID_fak
                                                ORDER BY
                                                    id DESC
                                            )
                                        ORDER BY
                                            id DESC
                                    )
                        LEFT JOIN
                            HM.SK            SK
                                ON TD.idSchematKs = SK.id
                        LEFT JOIN
                            HM.SD            SD
                                ON SD.kod =
                                    (
                                        SELECT TOP (1)
                                            kod
                                        FROM
                                            HM.SD
                                        WHERE
                                            idTypDok = TD.id
                                            AND aktywny = 1
                                        ORDER BY
                                            id ASC
                                    )
                                   AND SD.idTypDok = TD.id
                        LEFT JOIN
                            SSCommon.STUsers us
                                ON DK.wystawil = us.Id
                        LEFT JOIN
                            SSCommon.vKhFK   vkh
                                ON vkh.id = DK.khid
                        LEFT JOIN
                            HM.INIFILE       ini
                                ON sekcja = 'KartotekiFK'
                                   AND klucz = '38'
                        LEFT JOIN
                            HM.KH            kon_kh
                                ON kon_kh.id = DK.magazyn
                    WHERE
                            DK.id = @ID_fak;



        DECLARE @ID_wz INT = (
                                 SELECT
                                     SCOPE_IDENTITY()
                             ); -- ID DOKUMENTU Z TABELI MG
        DECLARE @NROZL_OPER INT = (
                                      SELECT
                                          COUNT(*)
                                      FROM
                                          HM.DP
                                      WHERE
                                          super = @ID_fak
                                  );
        UPDATE
            HM.MG
        SET
            kod =
                (
                    SELECT
                            HM.Hm_podajkod(
                                              '', serianr, sd.szablon, DAY(GETDATE()), MONTH(GETDATE()), YEAR(GETDATE()),
                                              us.LoginName, CASE ini.napis
                                                                WHEN '4'
                                                                    THEN vkh.AccountNo
                                                                WHEN '2'
                                                                    THEN vkh.IdFK
                                                                ELSE
                                                                    0
                                                            END, kon_kh.khfk, kon_kh.kod, dk.magazyn,
                                (
                                    SELECT
                                        waluta
                                    FROM
                                        HM.DK
                                    WHERE
                                        id = @ID_fak
                                )
                                          ) AS kod
                    FROM
                            HM.MG            dk
                        JOIN
                            HM.TD            typd
                                ON typd.kod = dk.typ_dk
                        JOIN
                            HM.SD            sd
                                ON dk.seria = sd.kod
                                   AND typd.id = sd.idTypDok
                        LEFT JOIN
                            SSCommon.STUsers us
                                ON dk.wystawil = us.Id
                        LEFT JOIN
                            SSCommon.vKhFK   vkh
                                ON vkh.id = dk.khid
                        LEFT JOIN
                            HM.INIFILE       ini
                                ON sekcja = 'KartotekiFK'
                                   AND klucz = '38'
                        LEFT JOIN
                            HM.KH            kon_kh
                                ON kon_kh.id = dk.magazyn
                    WHERE
                            dk.id = @ID_wz
                )
        --from hm.MG dk
        WHERE
            id = @ID_wz;
        --Transakcja dla wz
        INSERT INTO HM.TR
            (
                flag,
                subtyp,
                typ,
                owner_base,
                owner_id,
                kod,
                id_kto,
                id_komu,
                dzial,
                ok,
                data,
                datarozl,
                termin,
                nrozl_oper,
                wartosc,
                wartosc_rozl,
                nrozlilosc,
                status
            )
                    SELECT
                        16896                    AS FLAG, -- DO WYLICZENIA 
                        3                        AS SUBTYP,
                        1                        AS TYP,
                        33                       AS OWNER_BASE,
                        @ID_wz                   AS OWNER_ID,
                        (
                            SELECT
                                kod
                            FROM
                                HM.MG
                            WHERE
                                id = @ID_wz
                        )                        AS KOD,
                        NULL                     AS ID_KTO,
                        DK.odid                  AS ID_KOMU,
                        ISNULL(   @id_magazynu,
                            (
                                SELECT TOP 1
                                    id2
                                FROM
                                    HM.ZZ
                                WHERE
                                    typ = 108
                                    AND baza2 = 20
                                    AND id2 = DK.magazyn
                            )
                              )                  AS DZIAL,
                        1                        AS OK,
                        DK.data,
                        CONVERT(DATE, GETDATE()) AS DATAROZL,
                        DK.plattermin            AS TERMIN,
                        0                        AS NROZL_OPER,
                        @wartoscWZ               AS WARTOSC,
                        @wartoscWZ               AS WARTOSC_ROZL,
                        0                        AS NROZLILOSC,
                        16                       STATUS
                    FROM
                        HM.DK DK
                    WHERE
                        DK.id = @ID_fak;
        DECLARE @ID_TRA_wz INT = (
                                     SELECT
                                         SCOPE_IDENTITY()
                                 );

        --Tworzenie powiązania między transakcjami
        INSERT INTO HM.PO
            (
                flag,
                typ,
                id1,
                id2
            )
                    SELECT
                        0          AS FLAG,
                        1          AS TYP,
                        TR.id      AS ID1, -- ID TRANSAKCJI FAKTURY 
                        @ID_TRA_wz AS ID2  -- ID TRANSAKCJI WZetki
                    FROM
                        HM.TR TR
                    WHERE
                        owner_id = @ID_fak
                        AND owner_base = 16;
        -- Aktualizacja transakcji dla faktury
        UPDATE
            HM.TR
        SET
            ok = 1,
            nrozl_oper = 0,
            nrozlilosc = 0,
            wartosc_rozl = wartosc,
            datarozl = CONVERT(DATE, GETDATE()),
            status = 16
        WHERE
            owner_id = @ID_fak
            AND owner_base = 16;

        -- Ustawienie faktury na realizacja przygotowana
        UPDATE
            HM.DK
        SET
            rozlmg = 33
        WHERE
            id = @ID_fak;
        --KONIEC NAGŁÓWKÓW
        --Tworzenie pozycji wz na podstawie pozycji faktury
        -- w cte pobieramy cene za towar w zależności od czy jest rezerwacja czy nie jak 
        -- nie ma rezerwacji to pobieramy z hm.sm wartosc/stan z podziałem na magazyn
        WITH cte
        AS (   SELECT
                       poz.lp AS lp,
                       rez.subtyp,
                       CASE
                           WHEN rez.wartosc > 0
                               THEN rez.wartosc
                           WHEN ISNULL(rez.wartosc, 0) = 0
                               THEN CASE
                                        WHEN dost.stan = 0
                                            THEN 0
                                        ELSE
                                            ISNULL(dost.wartosc / ISNULL(dost.stan, 1), 0)
                                    END
                           ELSE
                               0
                       END    AS wartSum,
                       poz.ilosc
               FROM
                       HM.DP poz
                   LEFT JOIN
                       HM.TW tow
                           ON tow.id = poz.idtw
                              AND tow.subtyp <> 1
                   LEFT JOIN
                       HM.RZ rez
                           ON poz.id = rez.idpozrz
                              AND bazapozrz = 18
                   LEFT JOIN
                       HM.SM dost
                           ON poz.idtw = dost.idtw
                              AND dost.magazyn = @id_magazynu
               WHERE
                       poz.super = @ID_fak)
        INSERT INTO HM.MZ
            (
                flag,
                subtyp,
                typ,
                super,
                lp,
                idkh,
                idtw,
                kod,
                data,
                opis,
                opisdod,
                ilosc,
                jm,
                grupacen,
                cena,
                wartNetto,
                idpozkoryg,
                rejestr,
                idlongname,
                magazyn,
                iloscjedn,
                iloscwp,
                przychod,
                rozchod,
                wartk,
                lwartk,
                schemat,
                jmwp,
                bufor,
                kompensata,
                superkoryg,
                iloscRLKS
            )
                    SELECT
                            0x200                    AS FLAG,   -- pozycja towaru kartotekowego, inne flagi z f-ry nie mają sensu dla WZ-ki
                            201                      AS SUBTYP,
                            DP.typ & 0xe			 AS TYP,	--(0x0e - 1110) kopiujemy tylko 3 flagi
                            @ID_wz                   AS SUPER,
                            ROW_NUMBER() OVER (ORDER BY
                                                   DP.lp
                                              )      AS lp,
                            nag_fak.odid             AS IDKH,
                            DP.idtw                  AS IDTW,
                            DP.kod                   AS KOD,
                            CONVERT(DATE, GETDATE()) AS DATA,
                            DP.opis                  AS OPIS,
                            DP.opisdod               AS OPISDOD,
                            DP.ilosc                 AS ILOSC,
                            DP.jm                    AS JM,
                            0                        AS GRUPACEN,
                            CASE cte.subtyp
                                WHEN 0
                                    THEN ROUND(wartSum / ISNULL(cte.ilosc, 1), 6)
                                ELSE
                                    ROUND(wartSum, 6)
                            END                      AS cena,
                            CASE cte.subtyp
                                WHEN 1
                                    THEN ROUND(wartSum * cte.ilosc, 2)
                                ELSE
                                    ROUND(wartSum, 2)
                            END                      AS wartNetto,
                            NULL                     AS IDPOZKORYG,
                            CASE --rejestr vat 
                                WHEN tw.odwrotneObc = 1
                                    THEN TD.idRejestrNP
                                ELSE
                                    TD.idRejestr
                            END                      AS REJESTR,
                            DP.idlongname            AS IDLONGNAME,
                            ISNULL(   @id_magazynu,
                                (
                                    SELECT TOP 1
                                        id2
                                    FROM
                                        HM.ZZ
                                    WHERE
                                        typ = 108
                                        AND baza2 = 20
                                        AND id1 = DP.magazyn
                                )
                                  )                  AS MAGAZYN,
                            DP.iloscjedn             AS ILOSCJEDN,
                            DP.iloscwp               AS ILOSCWP,
                            0                        AS przychod,
                            CASE cte.subtyp
                                WHEN 1
                                    THEN ROUND(wartSum * cte.ilosc, 2)
                                ELSE
                                    ROUND(wartSum, 2)
                            END                      AS rozchod,
                            0                        AS wartk,
                            0                        AS lwartk,
                            DP.schemat               AS SCHEMAT,
                            DP.jmwp                  AS JMWP,
                            1                        AS BUFOR,
                            DP.kompensata            AS KOMPENSATA,
                            @ID_wz                   AS SUPERKORYG,
                            0                        AS ILOSCRLKS
                    FROM
                            HM.DP DP
                        LEFT JOIN
                            HM.DK nag_fak
                                ON nag_fak.id = DP.super
                        LEFT JOIN
                            HM.TW tw
                                ON tw.id = DP.idtw
                                   AND tw.subtyp <> 1
                        JOIN
                            HM.TD TD
                                ON TD.id =
                                    (
                                        SELECT TOP (1)
                                            idDokSkojarz
                                        FROM
                                            HM.TD
                                        WHERE
                                            kod =
                                            (
                                                SELECT TOP (1)
                                                    typ_dk
                                                FROM
                                                    HM.DK
                                                WHERE
                                                    id = @ID_fak
                                                ORDER BY
                                                    id DESC
                                            )
                                        ORDER BY
                                            id DESC
                                    )
                        LEFT JOIN
                            cte   cte
                                ON DP.lp = cte.lp
                    WHERE
                            DP.super = @ID_fak
                            AND tw.subtyp <> 1
                            AND (0x1000 <> (0x1000 & DP.flag))
                    ORDER BY
                            DP.lp;
        ---- ustawienie operacji faktury jako zrealizowane w całośći
        UPDATE
            HM.OP
        SET
            ok = 1,
            datarozl = CONVERT(DATE, GETDATE()),
            ilosc_rozl = ilosc,
            wartosc_rozl = wartosc
        WHERE
            id_transakcji = @id_trans_fak;
        --Tworzenie operacji dla WZ

        DECLARE @TMP_TABLE_ID_DP TABLE
            (
                ID    INT,
                LP    INT,
                ID_CO INT
            );
        DECLARE @TMP_TABLE_ID_OP_SPR TABLE
            (
                ID    INT,
                ID_CO INT
            );
        WITH cte
        AS (   SELECT
                       zp.lp                    AS lp,
                       0                        AS flag,
                       3                        AS subtyp,
                       37                       AS owner_base,
                       OP.kod                   AS kod,
                       OP.id_co                 AS id_co,
                       @ID_TRA_wz               AS id_transakcji,
                       1                        AS ok,
                       CONVERT(DATE, GETDATE()) AS datarozl,
                       OP.ilosc                 AS ilosc,
                       OP.ilosc                 AS ilosc_rozl,
                       OP.wartosc               AS wartosc,
                       OP.wartosc_rozl          AS wartosc_rozl
               FROM
                       HM.OP OP
                   LEFT JOIN
                       HM.DP zp
                           ON zp.id = OP.owner_id
                              AND OP.owner_base = 18
               WHERE
                       id_transakcji = @id_trans_fak
                       AND (0x8000 & OP.flag <> 0x8000))
        INSERT INTO HM.OP
            (
                flag,
                subtyp,
                owner_base,
                owner_id,
                kod,
                id_co,
                id_transakcji,
                ok,
                datarozl,
                ilosc,
                ilosc_rozl,
                wartosc,
                wartosc_rozl
            )
        OUTPUT
            INSERTED.id,
            INSERTED.id_co
        INTO @TMP_TABLE_ID_OP_SPR
                    SELECT
                            c.flag,
                            c.subtyp,
                            c.owner_base,
                            pf.id                                                     AS owner_id,
                            c.kod,
                            c.id_co,
                            c.id_transakcji,
                            c.ok,
                            c.datarozl,
                            c.ilosc,
                            c.ilosc_rozl,
                            ROUND(ISNULL((pf.ilosc * (pf.rozchod + pf.wartk)), 0), 2) AS wartosc,
                            c.wartosc_rozl
                    FROM
                            cte   AS c
                        JOIN
                            HM.MZ AS pf
                                ON pf.lp = c.lp
                                   AND pf.idtw = c.id_co
                                   AND pf.super = @ID_wz
                    ORDER BY
                            c.lp;
        INSERT INTO HM.RO
            (
                flag,
                typ,
                id1,
                id2,
                ilosc,
                wartosc,
                data
            )
                    SELECT
                            0                        AS FLAG,
                            1                        AS TYP,
                            zam.id                   AS ID1, -- ID DOKUMENTU DP 
                            fak.id                   AS ID2, -- ID OP SPRZEDAZY 
                            zam.ilosc                AS ILOSC,
                            zam.wartosc              AS WARTOSC,
                            CONVERT(DATE, GETDATE()) AS DATA
                    FROM
                            (
                                SELECT
                                        DP.lp AS lp_zam,
                                        op.id,
                                        op.ilosc,
                                        op.wartosc
                                FROM
                                        HM.OP op
                                    JOIN
                                        HM.DP
                                            ON DP.id = op.owner_id
                                               AND op.owner_base = 18
                                WHERE
                                        id_transakcji = @id_trans_fak
                                        AND (0x8000 & op.flag <> 0x8000)
                            ) zam
                        JOIN
                            (
                                SELECT
                                        mz.lp AS lp_zam,
                                        op.id
                                FROM
                                        HM.OP op
                                    JOIN
                                        HM.MZ mz
                                            ON mz.id = op.owner_id
                                               AND op.owner_base = 37
                                WHERE
                                        id_transakcji = @ID_TRA_wz
                            ) fak
                                ON zam.lp_zam = fak.lp_zam;




        --Kopiowanie idlongname w TX
        DECLARE @TMP_TABLE_ID_TX_IDLONGNAME TABLE
            (
                lp INT,
                ID INT
            );
        INSERT INTO HM.TX
            (
                flag,
                subtyp,
                typ,
                opis
            )
        OUTPUT
            Inserted.subtyp,
            Inserted.id
        INTO @TMP_TABLE_ID_TX_IDLONGNAME
            (
                lp,
                ID
            )
                    SELECT
                            longname.flag,
                                                  --longname.subtyp,
                            poz_fak.lp AS subtyp, -- pole jest nie wykorzystywane w systemie, więc wykorzystamy je do wrzucenia tymczasowo lp dla pozycji
                                                  -- uprości to znacznie algorytm dopasowania pozycji zam do wz przy długich nazwach
                            longname.typ,
                            longname.opis
                    FROM
                            HM.DP poz_fak
                        JOIN
                            HM.TX longname
                                ON longname.id = poz_fak.idlongname
                    WHERE
                            poz_fak.super = @ID_fak
                    ORDER BY
                            poz_fak.lp;
        --update idlongname w pozycjach wz

        UPDATE
                wzeta
        SET
                wzeta.idlongname = tempik.ID
        FROM
                HM.MZ                       AS wzeta
            JOIN
                @TMP_TABLE_ID_TX_IDLONGNAME tempik
                    ON tempik.lp = wzeta.lp
        WHERE
                wzeta.super = @ID_wz;

        --Rezerwacje - dla dokumentu wz w buforze przepisujemy rezerwacje z uwzględnieniem kompletów
        WITH qjk
        AS (   SELECT
                   DP.lp AS lp,
                   DP.idtw,
                   DP.id
               FROM
                   HM.DP
               WHERE
                   super = @ID_fak
                   AND (0x1000 <> (0x1000 & DP.flag)))
        INSERT INTO HM.RZ
            (
                flag,
                subtyp,
                typ,
                idtw,
                idkh,
                magazyn,
                data,
                termin,
                iloscrz,
                iloscrl,
                wartosc,
                iddokrz,
                bazadokrz,
                idpozrz,
                bazapozrz
            )
                    SELECT
                            rz_zam.flag,
                            rz_zam.subtyp,
                            rz_zam.typ,
                            dp.idtw,
                            rz_zam.idkh,
                            rz_zam.magazyn,
                            CONVERT(DATE, GETDATE()),
                            CONVERT(DATE, DATEADD(d, 7, GETDATE())),
                            rz_zam.iloscrz,
                            rz_zam.iloscrz,
                            wartosc,
                            @ID_wz,
                            33,
                            mz.id,
                            37
                    FROM
                            qjk   AS dp
                        JOIN
                            HM.MZ mz
                                ON dp.lp = mz.lp
                        JOIN
                            HM.RZ rz_zam
                                ON rz_zam.idpozrz = dp.id
                                   AND rz_zam.bazapozrz = 18
                    WHERE
                            mz.super = @ID_wz
                    ORDER BY
                            mz.lp ASC;




        -- Kopiowanie powiązań do PW
        INSERT INTO HM.PW
            (
                flag,
                subtyp,
                typ,
                iddkmg,
                idmg,
                iddw,
                idtw,
                ilosc,
                wartosc,
                ilosczreal,
                idkoryg,
                data
            )
                    SELECT
                            p.flag,
                            p.subtyp,
                            p.typ,
                            p.iddkmg,
                            wz.id,
                            p.iddw,
                            p.idtw,
                            p.ilosc,
                            p.wartosc,
                            p.ilosc,
                            --wz.iloscrl,
                            --wz.wartosc,
                            --wz.iloscrz,
                            p.idkoryg,
                            CONVERT(DATE, GETDATE())
                    FROM
                            (
                                SELECT
                                        MZ.lp AS lp_zam,
                                        rez.*
                                FROM
                                        HM.RZ rez
                                    JOIN
                                        HM.MZ
                                            ON MZ.id = rez.idpozrz
                                WHERE
                                        iddokrz = @ID_wz
                                        AND bazadokrz = 33
                            )     wz
                        JOIN
                            (
                                SELECT
                                        dp.lp AS lp_fak,
                                        rez.*
                                FROM
                                        HM.RZ rez
                                    JOIN
                                        HM.DP dp
                                            ON dp.id = rez.idpozrz
                                WHERE
                                        iddokrz = @ID_fak
                                        AND bazadokrz = 16
                            )     fak
                                ON wz.lp_zam = fak.lp_fak
                        JOIN
                            HM.PW p
                                ON p.idmg = fak.id
                                   AND p.typ = 26
                    ORDER BY
                            lp_zam DESC;

        ---- Aktualizacja hm.PW związanych z zamówieniem 
        UPDATE
            HM.PW
        SET
            ilosc = 0,
            wartosc = 0,
            ilosczreal = 0
        WHERE
            idmg IN (
                        SELECT
                            id
                        FROM
                            HM.RZ
                        WHERE
                            iddokrz = @ID_fak
                            AND bazadokrz = 16
                    )
            AND typ = 26;

        --Zerujemy wartości dla rezerwacji faktury
        UPDATE
            HM.RZ
        SET
            iloscrz = 0,
            iloscrl = 0,
            wartosc = 0
        WHERE
            iddokrz = @ID_fak
            AND bazadokrz = 16;

        INSERT INTO HM.ZZ
            (
                flag,
                subtyp,
                typ,
                baza1,
                id1,
                baza2,
                id2,
                kod1,
                kod2,
                data,
                termin,
                ilosc,
                cena,
                waluta,
                opis,
                id3,
                baza3,
                ilosc2,
                magazyn,
                iddkreal,
                id3pos
            )
                    SELECT
                            0           AS flag,     -- flag - smallint
                            0           AS subtyp,   -- subtyp - smallint
                            96          AS typ,      -- typ - smallint
                            152         AS baza1,    -- baza1 - smallint
                            zam.id1     AS id1,      -- id1 - int
                            152         AS baza2,    -- baza2 - smallint
                            fak.id2     AS id2,      -- id2 - int
                            ''          AS kod1,     -- kod1 - varchar(40)
                            ''          AS kod2,     -- kod2 - varchar(40)
                            NULL        AS data,     -- data - datetime
                            NULL        AS termin,   -- termin - datetime
                            fak.iloscrz AS ilosc,    -- ilosc - float
                            0           AS cena,     -- cena - float
                            ''          AS waluta,   -- waluta - varchar(3)
                            ''          AS opis,     -- opis - varchar(100)
                            NULL        AS id3,      -- id3 - int
                            0           AS baza3,    -- baza3 - smallint
                            0           AS ilosc2,   -- ilosc2 - float
                            0           AS magazyn,  -- magazyn - int
                            NULL        AS iddkreal, -- iddkreal - int
                            NULL        AS id3pos    -- id3pos - int
                    FROM
                            (
                                SELECT
                                        dp.lp        AS lp,
                                        rez_zam.id   AS id1,
                                        rez_zam.idtw AS zam_idtw
                                FROM
                                        HM.RZ rez_zam
                                    JOIN
                                        HM.DP dp
                                            ON dp.id = rez_zam.idpozrz
                                WHERE
                                        rez_zam.iddokrz = @ID_fak
                                        AND rez_zam.bazadokrz = 16
                            ) zam
                        JOIN
                            (
                                SELECT
                                        mz.lp        AS lp,
                                        rez_fak.id   AS id2,
                                        rez_fak.iloscrz,
                                        rez_fak.iloscrl,
                                        rez_fak.idtw AS fak_idtw
                                FROM
                                        HM.RZ rez_fak
                                    JOIN
                                        HM.MZ mz
                                            ON mz.id = rez_fak.idpozrz
                                WHERE
                                        rez_fak.iddokrz = @ID_wz
                                        AND rez_fak.bazadokrz = 33
                            ) fak
                                ON zam.lp = fak.lp
                                   AND zam.zam_idtw = fak.fak_idtw
                    UNION
                    SELECT
                            0           AS flag,     -- flag - smallint
                            0           AS subtyp,   -- subtyp - smallint
                            96          AS typ,      -- typ - smallint
                            36          AS baza1,    -- baza1 - smallint
                            zam.id1     AS id1,      -- id1 - int
                            36          AS baza2,    -- baza2 - smallint
                            fak.id2     AS id2,      -- id2 - int
                            ''          AS kod1,     -- kod1 - varchar(40)
                            ''          AS kod2,     -- kod2 - varchar(40)
                            NULL        AS data,     -- data - datetime
                            NULL        AS termin,   -- termin - datetime
                            fak.iloscrz AS ilosc,    -- ilosc - float
                            0           AS cena,     -- cena - float
                            ''          AS waluta,   -- waluta - varchar(3)
                            ''          AS opis,     -- opis - varchar(100)
                            NULL        AS id3,      -- id3 - int
                            0           AS baza3,    -- baza3 - smallint
                            0           AS ilosc2,   -- ilosc2 - float
                            0           AS magazyn,  -- magazyn - int
                            NULL        AS iddkreal, -- iddkreal - int
                            NULL        AS id3pos    -- id3pos - int
                    FROM
                            (
                                SELECT
                                        dp.lp        AS lp,
                                        pow.id       AS id1,
                                        rez_zam.idtw AS zam_idtw,
										pow.iddw	 AS iddw
                                FROM
                                        HM.RZ rez_zam
                                    JOIN
                                        HM.DP dp
                                            ON dp.id = rez_zam.idpozrz
                                    JOIN
                                        HM.PW pow
                                            ON rez_zam.id = pow.idmg
                                               AND pow.typ = 26
                                WHERE
                                        rez_zam.iddokrz = @ID_fak
                                        AND rez_zam.bazadokrz = 16
                            ) zam
                        JOIN
                            (
                                SELECT
                                        mz.lp        AS lp,
                                        pow.id       AS id2,
                                        pow.ilosc    AS iloscrz,
                                        rez_fak.iloscrl,
                                        rez_fak.idtw AS fak_idtw,
										pow.iddw	 AS iddw
                                FROM
                                        HM.RZ rez_fak
                                    JOIN
                                        HM.MZ mz
                                            ON mz.id = rez_fak.idpozrz
                                    JOIN
                                        HM.PW pow
                                            ON rez_fak.id = pow.idmg
                                               AND pow.typ = 26
                                WHERE
                                        rez_fak.iddokrz = @ID_wz
                                        AND rez_fak.bazadokrz = 33
                            ) fak
                                ON zam.lp = fak.lp
                                   AND zam.zam_idtw = fak.fak_idtw
								   AND zam.iddw = fak.iddw;

        -- Rozgłaszamy że coś dodaliśmy
        INSERT INTO LOCAL_LOG
            (
                baseName,
                rec_id,
                operation,
                term
            )
        VALUES
            (
                'MG', @ID_wz, 3, @@SPID
            ),
            (
                'DK', @ID_fak, 3, @@SPID
            );
        -- kopiowanie wymiarów

        --exec [dim].[DimWorkFlow_HM_MZ] @id_wz, @userID ,@id_fak,null;
	   --kopiowanie wartości pól własnych 
		EXEC hm.CopyOwnFieldsFromFVStoWarehouse @ID_fak;
        --zwracamy id dok wz

        SET @idDk = @ID_wz;
        RETURN @err;
    END;

