ALTER VIEW HM.ProductPricingInfos
AS
Select 
tw.id as ProductId,
tw.subtypext as TypeId,
tw.nazwa as ProductName,
tw.kod as ProductShortcut,
tw.vatsp as VatRateId,
tw.kodpaskowy as Barcode,
tw.kontofk as Account,
tw.sww as PKWiU,
CASE 	 
	WHEN TW.znacznik = 65 THEN 'A'
	WHEN TW.znacznik = 66 THEN 'B'
	WHEN TW.znacznik = 67 THEN 'C'
	WHEN TW.znacznik = 68 THEN 'D'
	WHEN TW.znacznik = 69 THEN 'E'
	WHEN TW.znacznik = 70 THEN 'F'
	WHEN TW.znacznik = 71 THEN 'G'
	WHEN TW.znacznik = 72 THEN 'H'
	WHEN TW.znacznik = 73 THEN 'I'
	WHEN TW.znacznik = 74 THEN 'J'
	WHEN TW.znacznik = 75 THEN 'K'
	WHEN TW.znacznik = 76 THEN 'L'
	WHEN TW.znacznik = 77 THEN 'M'
	WHEN TW.znacznik = 78 THEN 'N'
	WHEN TW.znacznik = 79 THEN 'O'
	WHEN TW.znacznik = 80 THEN 'P'
	WHEN TW.znacznik = 81 THEN 'Q'
	WHEN TW.znacznik = 82 THEN 'R'
	WHEN TW.znacznik = 83 THEN 'S'
	WHEN TW.znacznik = 84 THEN 'T'
	WHEN TW.znacznik = 85 THEN 'U'
	WHEN TW.znacznik = 86 THEN 'V'
	WHEN TW.znacznik = 87 THEN 'W'
	WHEN TW.znacznik = 88 THEN 'X'
	WHEN TW.znacznik = 89 THEN 'Y'
	WHEN TW.znacznik = 90 THEN 'Z'
	WHEN TW.znacznik = 91 THEN '0'
	WHEN TW.znacznik = 92 THEN '1'
	WHEN TW.znacznik = 93 THEN '2'
	WHEN TW.znacznik = 94 THEN '3'
	WHEN TW.znacznik = 95 THEN '4'
	WHEN TW.znacznik = 96 THEN '5'
	WHEN TW.znacznik = 97 THEN '6'
	WHEN TW.znacznik = 98 THEN '7'
	WHEN TW.znacznik = 99 THEN '8'
	WHEN TW.znacznik = 100 THEN '9'
ELSE '' END as Tag,
stVat.kod as VatRateShortcut,
cat.name as CatalogName,
cat.id as CatalogId,
KIND.id as ProductKindId,
KIND.name as ProductKindName,
Cast(stVat.wartosc as decimal(18,2)) as VatRateValue,
CASE 
    WHEN tw.zaokrag = 51 THEN 3 
	WHEN tw.zaokrag = 52 then 4 
	WHEN 2 - tw.zaokrag < 0 THEN 0
	ELSE 2 - tw.zaokrag
END as rounding,
CASE 
	WHEN tw.zaokrag = 51 THEN '0,001'
	WHEN tw.zaokrag = 52 THEN '0,0001'
	WHEN tw.zaokrag = 0 THEN '0,01'
	WHEN tw.zaokrag = 1 THEN '0,1'
	WHEN tw.zaokrag = 2 THEN '1'
	WHEN tw.zaokrag = 3 THEN '10'
	WHEN tw.zaokrag = 4 THEN '100'
	ELSE '0,01'
END as roundingLabel 
From HM.TW TW
	LEFT OUTER JOIN HM.XT stVat
            ON stVat.id = tw.vatsp
	LEFT OUTER JOIN (
		Select
			id as id,
			kod as name
		from HM.XT where root=2200
	) as CAT ON (CAT.id = TW.katalog)
	LEFT OUTER JOIN (
		SELECT 
			id as id,
			kod as name 
		FROM HM.TW WHERE typ = 110
	) as KIND ON (KIND.id = TW.rodzaj)
where tw.typ = 0